// Buffer.h

#ifndef _BUFFER_h
#define _BUFFER_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

#define BUFFER_LENGTH 2048

enum class BufferStatus
{
	OK, FULL
};

class Buffer
{
 public:
	 Buffer();	 
	 BufferStatus addData(float data);
	 void reset();
	 float *getData();
	 unsigned int getLength();
	 unsigned int getIndex();
 private:
	unsigned int _length;
	unsigned int _index;
	float _data[BUFFER_LENGTH];
};

#endif