// 
// 
// 

#include "HeaveFilter.h"
#include "FilterParam.h"

float HeaveFilter::estimateVelocity(float accVal, float w_c, float accSampleTime) {
	static float zeta = (float)(1.0f / sqrt(2.0f));
	
	// Calculate output
	float v_hat = _velEstStates[1];

	// Calculate states for the next time step
	_velEstStates[0] = _velEstStates[0] + accSampleTime*_velEstStates[1];
	_velEstStates[1] = -sq(w_c)*accSampleTime*_velEstStates[0] + (1.0f - 2.0f*zeta*w_c*accSampleTime)*_velEstStates[1] + accSampleTime*accVal;

	return v_hat;
}

float HeaveFilter::phaseCorrection(float estimatedVelocity, FilterParam params, float accSampleTime) {
	// Calculate output
	float v_hatCorrected = (params.a0 - params.a1*params.b0)*_phaseState + params.a1*estimatedVelocity;

	// Calculate the state for the next time step
	_phaseState = (1.0f - params.b0*accSampleTime)*_phaseState + accSampleTime*estimatedVelocity;

	return v_hatCorrected;
}


