// HeaveFilter.h

#ifndef _HEAVEFILTER_h
#define _HEAVEFILTER_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

// Forward declaration
struct FilterParam;

class HeaveFilter
{
 public:
	 float estimateVelocity(float accVal, float w_c, float accSampleTime);
	 float phaseCorrection(float estimatedVelocity, FilterParam params, float accSampleTime);
 private:
	 // Velocity estimation/phase correction states
	 float _velEstStates[2] = { 0.0, 0.0 };
	 float _phaseState = 0.0;
};

#endif

