// ParamEstimation.h

#ifndef _PARAMESTIMATION_h
#define _PARAMESTIMATION_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

// Forward declaration:
struct FilterParam;

class ParamEstimation
{
 public:
	 static void calculateFilterParametersTask(void *pvParameters);
 private:
	 static float getDominantWaveFreq(float *amplitudeArray, float sampleTime);
	 static float getDominantWaveAmplitude(float w, float *accelerationData, float sigma2);
	 static void getFilterParams(float w, float A, float dw, float sampleTimeAcc, float sigma2, float T_2max, float psd, FilterParam* params);
	 static void RealFFT(float *source, float *destination);
};

#endif

